package pipe.gui;

import pipe.dataLayer.*;

import javax.swing.*;
import java.util.*;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputAdapter;


/**
 * Class used to implement methods corresponding to mouse events on places.
 *
 */

public class PlaceHandler extends PetriNetObjectHandler {

  public PlaceHandler(CreateGui creategui, Container contentpane) {
    super(creategui,contentpane);
  }

  /** Creates the popup menu that the user will see when they right click on a component */
  public JPopupMenu getPopup(MouseEvent e) {
    JPopupMenu popup = new JPopupMenu();
    JMenuItem menuItem = new JMenuItem(new LabelAction(contentPane,e.getComponent()));
    menuItem.setText("Add label");
    popup.add(menuItem);

    menuItem = new JMenuItem(new DeleteAction(contentPane,e.getComponent(),theApp));
    menuItem.setText("Delete");
    popup.add(menuItem);

    menuItem = new JMenuItem(new EditTokenAction(contentPane,(Place)e.getComponent()));
    menuItem.setText("Edit Tokens");
    popup.add(menuItem);

    return popup;
  }

  public void mouseClicked(MouseEvent e) {

    //System.out.println(ModeAdaptor.getMode());
    Place thisPlace = (Place)e.getComponent();

    int currentMarking = thisPlace.getCurrentMarking();
    switch(ModeAdaptor.getMode()) {

      case ADDTOKEN:
        if (e.getButton() == MouseEvent.BUTTON1) {
          if (currentMarking == 0)
            thisPlace.setCurrentMarking(1);
          else {
            currentMarking++;
            thisPlace.setCurrentMarking(currentMarking);
          }
          thisPlace.repaint();
        } else if (e.getButton() == MouseEvent.BUTTON3) {


        };  break;
        case DELTOKEN:
          if (e.getButton() == MouseEvent.BUTTON1) {
            if (currentMarking > 0) {
              currentMarking--;
              thisPlace.setCurrentMarking(currentMarking);
              thisPlace.repaint();
            }
          }; break;
          default: ;
    }

  }
}















